@echo off

set path_back=%PATH%
set PATH=..\bin

if exist *.o (
	del /Q *.o > nul
)
if exist *.ihx (
	del /Q *.ihx > nul
)
if exist *.map (
	del /Q *.map > nul
)
if exist *.bin (
	del /Q *.bin > nul
)

echo [ASSEMBLE] bgmdriver.asm
as-z80 -o bgmdriver.o bgmdriver.asm

echo [ASSEMBLE] sca_player.asm
as-z80 -o sca_player.o sca_player.asm

echo [ASSEMBLE] sca_shot.asm
as-z80 -o sca_shot.o sca_shot.asm

echo [ASSEMBLE] sca_sprite.asm
as-z80 -o sca_sprite.o sca_sprite.asm

echo [ASSEMBLE] sca_enemy_man.asm
as-z80 -o sca_enemy_man.o sca_enemy_man.asm

echo [ASSEMBLE] sca_clash.asm
as-z80 -o sca_clash.o sca_clash.asm

echo [ASSEMBLE] sca_enemy1.asm
as-z80 -o sca_enemy1.o sca_enemy1.asm

echo [ASSEMBLE] sca_enemy2.asm
as-z80 -o sca_enemy2.o sca_enemy2.asm

echo [ASSEMBLE] sca_enemy3.asm
as-z80 -o sca_enemy3.o sca_enemy3.asm

echo [ASSEMBLE] sca_enemy4.asm
as-z80 -o sca_enemy4.o sca_enemy4.asm

echo [ASSEMBLE] sca_enemy5.asm
as-z80 -o sca_enemy5.o sca_enemy5.asm

echo [ASSEMBLE] sca_enemy_boss1.asm
as-z80 -o sca_enemy_boss1.o sca_enemy_boss1.asm

echo [ASSEMBLE] sca_enemy_bomb.asm
as-z80 -o sca_enemy_bomb.o sca_enemy_bomb.asm

echo [ASSEMBLE] sca_background.asm
as-z80 -o sca_background.o sca_background.asm

echo [ASSEMBLE] sca_random.asm
as-z80 -o sca_random.o sca_random.asm

echo [ASSEMBLE] sca_vsync.asm
as-z80 -o sca_vsync.o sca_vsync.asm

echo [ASSEMBLE] sca_score.asm
as-z80 -o sca_score.o sca_score.asm

echo [ASSEMBLE] sca_title.asm
as-z80 -o sca_title.o sca_title.asm

echo [ASSEMBLE] sca_main.asm
as-z80 -o sca_main.o sca_main.asm

echo [LINK] sca.ihx
link-z80 -nf sca.link

echo [BSAVE] sca.bin
ihx2bin sca.ihx sca.bin > nul

move sca.bin diskimage

del /Q *.o

set PATH=%path_back%
pause
