; -----------------------------------------------------------------------------
;	@
; -----------------------------------------------------------------------------

		.include	"sca_info.asm"

		.area	CODE (ABS)

; -----------------------------------------------------------------------------
;	@̏iQ[Jnj
;	input:
;		ix	...	@̃AhX
;	output
;		Ȃ
;	break
;		Ȃ
;	comment
;		@́AL̍\Ƃ
;			unsigned short	x			8bitW, 8bit͏
;			unsigned short	y			8bitW, 8bit͏
;			unsigned short	p_vector	ړxNge[ũAhX
;			unsigned char	shot_power	Vbgp[
; -----------------------------------------------------------------------------
player_init::
		push	hl
		push	ix
		pop		hl
		; ړxNge[ũAhX
		inc		hl
		inc		hl
		inc		hl
		inc		hl
		ld		bc, #player_move_vector0
		ld		(hl), c
		inc		hl
		ld		(hl), b
		inc		hl
		; Vbgp[
		ld		(hl), #2
		; @񏉊
		xor		a
		ld		(player_speed), a
		ld		(player_shot), a
		ld		(player_invincibility), a
		ld		a, #4
		ld		(player_shield), a
		pop		hl
		ret

; -----------------------------------------------------------------------------
;	@̏iXe[WJnj
;	input:
;		ix	...	@̃AhX
;	output
;		Ȃ
;	break
;		Ȃ
;	comment
;		@́AL̍\Ƃ
;			unsigned short	x			8bitW, 8bit͏
;			unsigned short	y			8bitW, 8bit͏
;			unsigned short	p_vector	ړxNge[ũAhX
;			unsigned char	shot_power	Vbgp[
; -----------------------------------------------------------------------------
player_stage_init::
		push	hl
		push	ix
		pop		hl
		; XW
		ld		(hl), #0
		inc		hl
		ld		(hl), #88
		inc		hl
		; YW
		ld		(hl), #0
		inc		hl
		ld		(hl), #(191-16)
		pop		hl
		ret

; -----------------------------------------------------------------------------
;	@̈ړ
;	input:
;		ix	...	@̃AhX
;	output
;		Ȃ
;	break
;		ixȊOS
; -----------------------------------------------------------------------------
player_move::
		; G[h
		ld		a, (player_invincibility)
		or		a
		jr		z, player_move_skip1
		inc		a
		jr		z, player_move_skip1			; fobOpG[h̏ꍇfNgȂ
		dec		a
		dec		a
		ld		(player_invincibility), a
player_move_skip1:
		push	ix
		; J[\L[̏Ԃ𓾂
		xor		a
		call	GTSTCK
		push	af
		; WCXeBbNP̏Ԃ𓾂
		ld		a, #1
		call	GTSTCK
		; J[\L[ԁAWCXeBbNPԂ~bNX
		pop		bc
		or		b
		; AhXItZbgɕϊ ( iy = p_vector + a * 4 )
		pop		ix
		rlca
		rlca
		ld		l, a
		ld		h, #0
		ld		c, SCA_INFO_PLAYER_MOVE_VEC_TBL_L(ix)
		ld		b, SCA_INFO_PLAYER_MOVE_VEC_TBL_H(ix)
		add		hl, bc
		push	hl
		pop		iy
		; XWɈړxNgZĐړ
		ld		l, SCA_INFO_XL(ix)
		ld		h, SCA_INFO_XH(ix)
		ld		c, 0(iy)
		ld		b, 1(iy)
		add		hl, bc
		; ʊOɂ͂ݏo`FbN
		ld		a, h
		cp		a, #(192-16)
		jr		c, player_move_x_success1
		; ͂ݏo𔻕
player_move_x_fail1:
		cp		a, #224
		; Ȃ獶[t
		ld		hl, #0			; tOω
		jr		nc, player_move_x_success1
		; EȂE[t
		ld		hl, #((191-16)*256+0)
player_move_x_success1:
		; XWXV
		ld		SCA_INFO_XL(ix), l
		ld		SCA_INFO_XH(ix), h
		ld		SCA_INFO_XH2(ix), h
		; YWɈړxNgZĐړ
		ld		l, SCA_INFO_YL(ix)
		ld		h, SCA_INFO_YH(ix)
		ld		c, 2(iy)
		ld		b, 3(iy)
		add		hl, bc
		; ʊOɂ͂ݏo`FbN
		ld		a, h
		cp		a, #(192-16)
		jr		c, player_move_y_success1
		; ͂ݏo𔻕
player_move_y_fail1:
		cp		a, #224
		; Ȃ[t
		ld		hl, #0			; tOω
		jr		nc, player_move_y_success1
		; Ȃ牺[t
		ld		hl, #((191-16)*256+0)
player_move_y_success1:
		; YWXV
		ld		SCA_INFO_YL(ix), l
		ld		SCA_INFO_YH(ix), h
		ld		SCA_INFO_YH2(ix), h
		ret

player_move_vector0:
		.dw		#0, #0			; E
		.dw		#0, #-256		; 
		.dw		#181, #-181		; ^
		.dw		#256, #0		; 
		.dw		#181, #181		; _
		.dw		#0, #256		; 
		.dw		#-181, #181		; ^
		.dw		#-256, #0		; 
		.dw		#-181, #-181	; _
		.dw		#0, #0			; E
		.dw		#0, #0			; E
		.dw		#0, #0			; E
		.dw		#0, #0			; E
		.dw		#0, #0			; E
		.dw		#0, #0			; E
		.dw		#0, #0			; E
		.dw		#0, #0			; E

player_speed::
		.db		#0				; @̈ړx 0`3 ̂SiK
player_shot::
		.db		#0				; @̒ëЗ 0`3 ̂SiK
player_shield::
		.db		#0				; @̃V[h 0`8 ̂XiKi0̓Q[I[o[j
player_invincibility::
		.db		#0				; 0: ʏ, 255: G, 1`254: 莞ԖG(l͎c莞, 1/60[sec]P)
